﻿
<script type="text/javascript" src="https://code.jquery.com/jquery-3.5.1.min.js"></script>
<script type="text/javascript" src="https://cdn3.devexpress.com/jslib/21.1.6/js/dx.all.js"></script>
<script src="~/js/sweetalert.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/xlsx/0.8.0/jszip.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/xlsx/0.8.0/xlsx.js"></script>
<script type="text/javascript" src="~/assets/plugins/dxDataGrid/exceljs/exceljs.min.js"></script>
<script type="text/javascript" src="~/assets/plugins/dxDataGrid/FileSaver/FileSaver.min.js"></script>
<link href="https://cdn.jsdelivr.net/npm/select2@4.1.0-rc.0/dist/css/select2.min.css" rel="stylesheet" />
<script src="https://cdn.jsdelivr.net/npm/select2@4.1.0-rc.0/dist/js/select2.min.js"></script>
<style>
    .ThongTinTiem,.ThongTinTiem2 {
        display:none;
    }
    .active {
        display:block;
    }
</style>
<script type="text/javascript">
    var flag_fixed = false;
	function createCookie(name, value, days) {
        var expires;

        if (days) {
            var date = new Date();
            date.setTime(date.getTime() + (days * 24 * 60 * 60 * 1000));
            expires = "; expires=" + date.toGMTString();
        } else {
            expires = "";
        }
        document.cookie = encodeURIComponent(name) + "=" + encodeURIComponent(value) + expires + "; path=/";
    }

    function readCookie(name) {
        var nameEQ = encodeURIComponent(name) + "=";
        var ca = document.cookie.split(';');
        for (var i = 0; i < ca.length; i++) {
            var c = ca[i];
            while (c.charAt(0) === ' ')
                c = c.substring(1, c.length);
            if (c.indexOf(nameEQ) === 0)
                return decodeURIComponent(c.substring(nameEQ.length, c.length));
        }
        return null;
    }

    function eraseCookie(name) {
        createCookie(name, "", -1);
    }

    $( document ).ready(function() {
        if (readCookie("DonViChiTiet")) {
            console.log(readCookie("DonViChiTiet"));
            $("#DonVi").val(readCookie("DonViChiTiet"));
            //$('#btnXem').click();
        }
    });
    function GetDuLieu(Loai) {
        var IdDonVi = $('#DonVi').val();
        if (IdDonVi != "") {
            $.ajax({
            type: "GET",
            url: '@Url.Action("GetAllNhanVienBaoCaoTiemChung", "Staff")',
            dataType: 'text',
            data: { IdDonVi: IdDonVi, TinhTrang: Loai},
            success: function (data) {
                var cData = JSON.parse(data);
                console.log(cData);
                
                $("#gridContainer").dxDataGrid({
                    dataSource: cData,
                    columns: [
                        {
                            dataField: "STT",
                            caption: "#",
                            width:50,
                            fixed: true,
                            fixedPosition: "left",
                            allowEditing: false
                        },{
                            dataField: "HoTen",
                            caption: "Họ và tên (*)",
                            allowEditing: false
                        },
                        {
                            dataField: "NgaySinh",
                            headerCellTemplate: function (header, info) {
                                $('<div>')
                                    .html("Ngày sinh </br>dạng dd/mm/yyyy (*)")
                                    .appendTo(header);
                            },
                            allowEditing: false,
                        },
                        {
                            dataField: "GioiTinh",
                            headerCellTemplate: function (header, info) {
                                $('<div>')
                                    .html("Giới tính (*)</br> (0:nam, 1:nữ)")
                                    .appendTo(header);
                            },
                            allowEditing: false,
                        },
                        {
                            dataField: "MaNhomDoiTuong",
                            headerCellTemplate: function (header, info) {
                                $('<div>')
                                    .html("Mã nhóm đối tượng ưu tiên (*)</br>(Tham khảo PL2)")
                                    .appendTo(header);
                            },
                            allowEditing: false,
                        },
                        {
                            dataField: "DonViCongTac",
                            caption: "Đơn vị công tác",
                            allowEditing: false,
                        },
                        {
                            dataField: "DienThoai",
                            headerCellTemplate: function (header, info) {
                                $('<div>')
                                    .html("Số điện thoại(*)</br>(Tối thiểu 10 số)")
                                    .appendTo(header);
                            },
                            allowEditing: false,
                        },
                        {
                            dataField: "CMND",
                            headerCellTemplate: function (header, info) {
                                $('<div>')
                                    .html("Số CMT/CCCD </br>(Loại 8/9/12 số)")
                                    .appendTo(header);
                            },
                            allowEditing: false,
                        },
                        {
                            dataField: "BHYT",
                            headerCellTemplate: function (header, info) {
                                $('<div>')
                                    .html("Số thẻ bảo hiểm y tế </br>(Mã thẻ 10/15 ký tự)")
                                    .appendTo(header);
                            },
                            allowEditing: false,
                        },
                        {
                                caption: "Nơi ở tạm trú (hiện tại) (*)(Tham khảo PL3)",
                                alignment: "center",
                                fixed: flag_fixed,
                                columns: [
                                    {
                                        caption: "Tỉnh/Thành phố",
                                        alignment: "center",
                                        columns: [{
                                            caption: "1",
                                            headerCellTemplate: function (container) {
                                                container.html('1').parent().css({ fontSize: '10px', backgroundColor: '#f7ffce' }).attr({ 'rowspan': '' });
                                            },
                                            dataField: "TenTinh",
                                            alignment: "center"
                                        }]
                                    },
                                    {
                                        caption: "Mã Tỉnh/Thành phố (*)",
                                        alignment: "center",
                                        columns: [{
                                            caption:"2",
                                            headerCellTemplate: function (container) {
                                                container.html('2').parent().css({ fontSize: '10px', backgroundColor: '#f7ffce' }).attr({ 'rowspan': '' });
                                            },
                                            dataField: "MaTinh",
                                            alignment: "center"
                                        }]
                                    },
                                    {
                                        caption: "Quận/Huyện",
                                        alignment: "center",
                                        columns: [{
                                            caption:"3",
                                            headerCellTemplate: function (container) {
                                                container.html('3').parent().css({ fontSize: '10px', backgroundColor: '#f7ffce' }).attr({ 'rowspan': '' });
                                            },
                                            dataField: "TenQuan",
                                            alignment: "center"
                                        }]
                                    },
                                    {
                                        caption: "Mã Quận/Huyện (*)",
                                        alignment: "center",
                                        columns: [{
                                            caption:"4",
                                            headerCellTemplate: function (container) {
                                                container.html('4').parent().css({ fontSize: '10px', backgroundColor: '#f7ffce' }).attr({ 'rowspan': '' });
                                            },
                                            dataField: "MaQuan",
                                            alignment: "center"
                                        }]
                                    },
                                    {
                                        caption: "Xã/Phường",
                                        alignment: "center",
                                        columns: [{
                                            caption:"5",
                                            headerCellTemplate: function (container) {
                                                container.html('4').parent().css({ fontSize: '10px', backgroundColor: '#f7ffce' }).attr({ 'rowspan': '' });
                                            },
                                            dataField: "TenPhuong",
                                            alignment: "center"
                                        }]
                                    },
                                    {
                                        caption: "Mã Xã/Phường",
                                        alignment: "center",
                                        columns: [{
                                            caption:"6",
                                            headerCellTemplate: function (container) {
                                                container.html('5').parent().css({ fontSize: '10px', backgroundColor: '#f7ffce' }).attr({ 'rowspan': '' });
                                            },
                                            dataField: "MaPhuong",
                                            alignment: "center"
                                        }]
                                    },
                                    {
                                        caption: "Địa chỉ chi tiết",
                                        alignment: "center",
                                        columns: [{
                                            caption:"7",
                                            headerCellTemplate: function (container) {
                                                container.html('5').parent().css({ fontSize: '10px', backgroundColor: '#f7ffce' }).attr({ 'rowspan': '' });
                                            },
                                            dataField: "DiaChi",
                                            alignment: "center"
                                        }]
                                    }
                                ]
                        },
                        {
                                caption: "Mũi 1",
                                alignment: "center",
                                fixed: flag_fixed,
                                columns: [
                                    {
                                        headerCellTemplate: function (header, info) {
                                            $('<div>')
                                                .html("Tên vắc xin (*)</br>(Tham khảo PL5)")
                                                .appendTo(header);
                                        },
                                        alignment: "center",
                                        columns: [{
                                            caption: "1",
                                            headerCellTemplate: function (container) {
                                                container.html('1').parent().css({ fontSize: '10px', backgroundColor: '#f7ffce' }).attr({ 'rowspan': '' });
                                            },
                                            dataField: "Mui1_TenVacxin",
                                            alignment: "center"
                                        }]
                                    },
                                    {
                                        headerCellTemplate: function (header, info) {
                                            $('<div>')
                                                .html("Ngày tiêm </br>dạng dd/mm/yyyy (*)")
                                                .appendTo(header);
                                        },
                                        alignment: "center",
                                        columns: [{
                                            caption:"2",
                                            headerCellTemplate: function (container) {
                                                container.html('3').parent().css({ fontSize: '10px', backgroundColor: '#f7ffce' }).attr({ 'rowspan': '' });
                                            },
                                            dataField: "Mui1_NgayTiem",
                                            alignment: "center"
                                        }]
                                    },
                                    {
                                        caption: "Lô vắc xin(*)",
                                        alignment: "center",
                                        columns: [{
                                            caption:"3",
                                            headerCellTemplate: function (container) {
                                                container.html('2').parent().css({ fontSize: '10px', backgroundColor: '#f7ffce' }).attr({ 'rowspan': '' });
                                            },
                                            dataField: "Mui1_SoLo",
                                            alignment: "center"
                                        }]
                                    },
                                    {
                                        headerCellTemplate: function (header, info) {
                                            $('<div>')
                                                .html("Địa điểm tiêm (*)</br>(Tham khảo PL4)")
                                                .appendTo(header);
                                        },
                                        alignment: "center",
                                        columns: [{
                                            caption:"4",
                                            headerCellTemplate: function (container) {
                                                container.html('4').parent().css({ fontSize: '10px', backgroundColor: '#f7ffce' }).attr({ 'rowspan': '' });
                                            },
                                            dataField: "Mui1_DiaDiem",
                                            alignment: "center"
                                        }]
                                    }
                                ]
                        },
                        {
                                caption: "Mũi 2",
                                alignment: "center",
                                fixed: flag_fixed,
                                columns: [
                                    {
                                        headerCellTemplate: function (header, info) {
                                            $('<div>')
                                                .html("Tên vắc xin (*)</br>(Tham khảo PL5)")
                                                .appendTo(header);
                                        },
                                        alignment: "center",
                                        columns: [{
                                            caption: "1",
                                            headerCellTemplate: function (container) {
                                                container.html('1').parent().css({ fontSize: '10px', backgroundColor: '#f7ffce' }).attr({ 'rowspan': '' });
                                            },
                                            dataField: "Mui2_TenVacxin",
                                            alignment: "center"
                                        }]
                                    },
                                    {
                                        headerCellTemplate: function (header, info) {
                                            $('<div>')
                                                .html("Ngày tiêm </br>dạng dd/mm/yyyy (*)")
                                                .appendTo(header);
                                        },
                                        alignment: "center",
                                        columns: [{
                                            caption:"2",
                                            headerCellTemplate: function (container) {
                                                container.html('3').parent().css({ fontSize: '10px', backgroundColor: '#f7ffce' }).attr({ 'rowspan': '' });
                                            },
                                            dataField: "Mui2_NgayTiem",
                                            alignment: "center"
                                        }]
                                    },
                                    {
                                        caption: "Lô vắc xin(*)",
                                        alignment: "center",
                                        columns: [{
                                            caption:"3",
                                            headerCellTemplate: function (container) {
                                                container.html('2').parent().css({ fontSize: '10px', backgroundColor: '#f7ffce' }).attr({ 'rowspan': '' });
                                            },
                                            dataField: "Mui2_SoLo",
                                            alignment: "center"
                                        }]
                                    },
                                    {
                                        headerCellTemplate: function (header, info) {
                                            $('<div>')
                                                .html("Địa điểm tiêm (*)</br>(Tham khảo PL4)")
                                                .appendTo(header);
                                        },
                                        alignment: "center",
                                        columns: [{
                                            caption:"4",
                                            headerCellTemplate: function (container) {
                                                container.html('4').parent().css({ fontSize: '10px', backgroundColor: '#f7ffce' }).attr({ 'rowspan': '' });
                                            },
                                            dataField: "Mui2_DiaDiem",
                                            alignment: "center"
                                        }]
                                    }
                                ]
                        },
                        {
                                caption: "Mũi 3",
                                alignment: "center",
                                fixed: flag_fixed,
                                columns: [
                                    {
                                        headerCellTemplate: function (header, info) {
                                            $('<div>')
                                                .html("Tên vắc xin (*)</br>(Tham khảo PL5)")
                                                .appendTo(header);
                                        },
                                        alignment: "center",
                                        columns: [{
                                            caption: "1",
                                            headerCellTemplate: function (container) {
                                                container.html('1').parent().css({ fontSize: '10px', backgroundColor: '#f7ffce' }).attr({ 'rowspan': '' });
                                            },
                                            dataField: "Mui3_TenVacxin",
                                            alignment: "center"
                                        }]
                                    },
                                    {
                                        headerCellTemplate: function (header, info) {
                                            $('<div>')
                                                .html("Ngày tiêm </br>dạng dd/mm/yyyy (*)")
                                                .appendTo(header);
                                        },
                                        alignment: "center",
                                        columns: [{
                                            caption:"2",
                                            headerCellTemplate: function (container) {
                                                container.html('3').parent().css({ fontSize: '10px', backgroundColor: '#f7ffce' }).attr({ 'rowspan': '' });
                                            },
                                            dataField: "Mui3_NgayTiem",
                                            alignment: "center"
                                        }]
                                    },
                                    {
                                        caption: "Lô vắc xin(*)",
                                        alignment: "center",
                                        columns: [{
                                            caption:"3",
                                            headerCellTemplate: function (container) {
                                                container.html('2').parent().css({ fontSize: '10px', backgroundColor: '#f7ffce' }).attr({ 'rowspan': '' });
                                            },
                                            dataField: "Mui3_SoLo",
                                            alignment: "center"
                                        }]
                                    },
                                    {
                                        headerCellTemplate: function (header, info) {
                                            $('<div>')
                                                .html("Địa điểm tiêm (*)</br>(Tham khảo PL4)")
                                                .appendTo(header);
                                        },
                                        alignment: "center",
                                        columns: [{
                                            caption:"4",
                                            headerCellTemplate: function (container) {
                                                container.html('4').parent().css({ fontSize: '10px', backgroundColor: '#f7ffce' }).attr({ 'rowspan': '' });
                                            },
                                            dataField: "Mui3_DiaDiem",
                                            alignment: "center"
                                        }]
                                    }
                                ]
                        },
                        {
                            dataField: "GhiChu",
                            caption: "Ghi chú",
                            allowEditing: false,
                        },
                        {
                            dataField: "KetQuaImport",
                            headerCellTemplate: function (header, info) {
                                $('<div>')
                                    .html("Kết quả import</br> (không điền ô này)")
                                    .appendTo(header);
                            },
                            allowEditing: false,
                        },
                    ],
                    showBorders: true,
                    searchPanel: {
                        visible: true,
                        highlightCaseSensitive: true
                    },
                    headerFilter: {
                        visible: true
                    },
                    loadPanel: {
                        enabled: false
                    },selection: {
                       // mode: "multiple"
                    },
                    //paging: { enabled: false },
                    columnAutoWidth: true,
                    scrolling: {
                        useNative: true,
                        scrollByContent: true,
                        scrollByThumb: true,
                        showScrollbar: "always" // or "onScroll" | "always" | "never"
                    }, export: {
                        enabled: true
                    },
                    onExporting(e) {
                      const workbook = new ExcelJS.Workbook();
                      const worksheet = workbook.addWorksheet('Sheet 1');
                      var borderStylePattern = { style: 'thick', color: { argb: 'FF7E7E7E' } };
                      DevExpress.excelExporter.exportDataGrid({
                        component: e.component,
                        worksheet,
                        //topLeftCell: { row: 0, column: 1 },
                      }).then((cellRange) => {


                      }).then(() => {
                        workbook.xlsx.writeBuffer().then((buffer) => {
                          saveAs(new Blob([buffer], { type: 'application/octet-stream' }), 'danh-sach-theo-doi-tiem-vacxin.xlsx');
                        });
                      });
                      e.cancel = true;
                    },
                });

            },
            error: function (e) {

            }
            });
        }
    }
    $('.btnDaVao').click(function () {
        GetDuLieu(1);
    });
    $('.btnDaTiem').click(function () {
        GetDuLieu(2);
    });
    $('.btnKhongTiemDuoc').click(function () {
        GetDuLieu(3);
    });
    $('.btnChuaTiem').click(function () {
        GetDuLieu(0);
    });
    $('#btnXem').click(function () {
        var IdDonVi = $('#DonVi').val();
        console.log(IdDonVi);
        if (IdDonVi != "") {
            createCookie("DonViChiTiet", IdDonVi);
            $.ajax({
            type: "GET",
            url: '@Url.Action("GetAllNhanVienBaoCaoTiemChung", "Staff")',
            dataType: 'text',
            data: {IdDonVi:IdDonVi},
            success: function (data) {
                var cData = JSON.parse(data);
                console.log(cData);
                var i = 0;
                var DaVao = 0;
                var DaTiem = 0;
                var ChuaTiem = 0;
                var KhongTiemDuoc = 0;
                for (i = 0; i < cData.length; i++) {
                    if (cData[i].DangKyTiemMui3 == 1)
                        DaVao++;
                    else if (cData[i].DangKyTiemMui3 == 2)
                        DaTiem++
                    else if (cData[i].DangKyTiemMui3 == 3)
                        KhongTiemDuoc++
                }
                ChuaTiem = DaVao + KhongTiemDuoc;
                $('#DaDangKy').html(cData.length);
                $('#DaVao').html(DaVao);
                $('#DaVao1').html(DaVao);
                $('#DaVao2').html(DaVao);
                $('#DaVao3').html(DaVao);
                $('#DaTiem').html(DaTiem);
                $('#ChuaTiem').html(ChuaTiem);
                $('#KhongTiemDuoc').html(KhongTiemDuoc);
                $("#gridContainer").dxDataGrid({
                    dataSource: cData,
                    columns: [
                        {
                            dataField: "STT",
                            caption: "#",
                            width:50,
                            fixed: true,
                            fixedPosition: "left",
                            allowEditing: false
                        },{
                            dataField: "HoTen",
                            caption: "Họ và tên (*)",
                            allowEditing: false,
                            fixed: true,
                            fixedPosition: "left",
                        },
                        {
                            dataField: "NgaySinh",
                            headerCellTemplate: function (header, info) {
                                $('<div>')
                                    .html("Ngày sinh </br>dạng dd/mm/yyyy (*)")
                                    .appendTo(header);
                            },
                            allowEditing: false,
                        },
                        {
                            dataField: "GioiTinh",
                            headerCellTemplate: function (header, info) {
                                $('<div>')
                                    .html("Giới tính (*)</br> (0:nam, 1:nữ)")
                                    .appendTo(header);
                            },
                            allowEditing: false,
                        },
                        {
                            dataField: "MaNhomDoiTuong",
                            headerCellTemplate: function (header, info) {
                                $('<div>')
                                    .html("Mã nhóm đối tượng ưu tiên (*)</br>(Tham khảo PL2)")
                                    .appendTo(header);
                            },
                            allowEditing: false,
                        },
                        {
                            dataField: "DonViCongTac",
                            caption: "Đơn vị công tác",
                            allowEditing: false,
                        },
                        {
                            dataField: "DienThoai",
                            headerCellTemplate: function (header, info) {
                                $('<div>')
                                    .html("Số điện thoại(*)</br>(Tối thiểu 10 số)")
                                    .appendTo(header);
                            },
                            allowEditing: false,
                        },
                        {
                            dataField: "CMND",
                            headerCellTemplate: function (header, info) {
                                $('<div>')
                                    .html("Số CMT/CCCD </br>(Loại 8/9/12 số)")
                                    .appendTo(header);
                            },
                            allowEditing: false,
                        },
                        {
                            dataField: "BHYT",
                            headerCellTemplate: function (header, info) {
                                $('<div>')
                                    .html("Số thẻ bảo hiểm y tế </br>(Mã thẻ 10/15 ký tự)")
                                    .appendTo(header);
                            },
                            allowEditing: false,
                        },
                        {
                                caption: "Nơi ở tạm trú (hiện tại) (*)(Tham khảo PL3)",
                                alignment: "center",
                                fixed: flag_fixed,
                                columns: [
                                    {
                                        caption: "Tỉnh/Thành phố",
                                        alignment: "center",
                                        columns: [{
                                            caption: "1",
                                            headerCellTemplate: function (container) {
                                                container.html('1').parent().css({ fontSize: '10px', backgroundColor: '#f7ffce' }).attr({ 'rowspan': '' });
                                            },
                                            dataField: "TenTinh",
                                            alignment: "center"
                                        }]
                                    },
                                    {
                                        caption: "Mã Tỉnh/Thành phố (*)",
                                        alignment: "center",
                                        columns: [{
                                            caption:"2",
                                            headerCellTemplate: function (container) {
                                                container.html('2').parent().css({ fontSize: '10px', backgroundColor: '#f7ffce' }).attr({ 'rowspan': '' });
                                            },
                                            dataField: "MaTinh",
                                            alignment: "center"
                                        }]
                                    },
                                    {
                                        caption: "Quận/Huyện",
                                        alignment: "center",
                                        columns: [{
                                            caption:"3",
                                            headerCellTemplate: function (container) {
                                                container.html('3').parent().css({ fontSize: '10px', backgroundColor: '#f7ffce' }).attr({ 'rowspan': '' });
                                            },
                                            dataField: "TenQuan",
                                            alignment: "center"
                                        }]
                                    },
                                    {
                                        caption: "Mã Quận/Huyện (*)",
                                        alignment: "center",
                                        columns: [{
                                            caption:"4",
                                            headerCellTemplate: function (container) {
                                                container.html('4').parent().css({ fontSize: '10px', backgroundColor: '#f7ffce' }).attr({ 'rowspan': '' });
                                            },
                                            dataField: "MaQuan",
                                            alignment: "center"
                                        }]
                                    },
                                    {
                                        caption: "Xã/Phường",
                                        alignment: "center",
                                        columns: [{
                                            caption:"5",
                                            headerCellTemplate: function (container) {
                                                container.html('4').parent().css({ fontSize: '10px', backgroundColor: '#f7ffce' }).attr({ 'rowspan': '' });
                                            },
                                            dataField: "TenPhuong",
                                            alignment: "center"
                                        }]
                                    },
                                    {
                                        caption: "Mã Xã/Phường",
                                        alignment: "center",
                                        columns: [{
                                            caption:"6",
                                            headerCellTemplate: function (container) {
                                                container.html('5').parent().css({ fontSize: '10px', backgroundColor: '#f7ffce' }).attr({ 'rowspan': '' });
                                            },
                                            dataField: "MaPhuong",
                                            alignment: "center"
                                        }]
                                    },
                                    {
                                        caption: "Địa chỉ chi tiết",
                                        alignment: "center",
                                        columns: [{
                                            caption:"7",
                                            headerCellTemplate: function (container) {
                                                container.html('5').parent().css({ fontSize: '10px', backgroundColor: '#f7ffce' }).attr({ 'rowspan': '' });
                                            },
                                            dataField: "DiaChi",
                                            alignment: "center"
                                        }]
                                    }
                                ]
                        },
                        {
                                caption: "Mũi 1",
                                alignment: "center",
                                fixed: flag_fixed,
                                columns: [
                                    {
                                        headerCellTemplate: function (header, info) {
                                            $('<div>')
                                                .html("Tên vắc xin (*)</br>(Tham khảo PL5)")
                                                .appendTo(header);
                                        },
                                        alignment: "center",
                                        columns: [{
                                            caption: "1",
                                            headerCellTemplate: function (container) {
                                                container.html('1').parent().css({ fontSize: '10px', backgroundColor: '#f7ffce' }).attr({ 'rowspan': '' });
                                            },
                                            dataField: "Mui1_TenVacxin",
                                            alignment: "center"
                                        }]
                                    },
                                    {
                                        headerCellTemplate: function (header, info) {
                                            $('<div>')
                                                .html("Ngày tiêm </br>dạng dd/mm/yyyy (*)")
                                                .appendTo(header);
                                        },
                                        alignment: "center",
                                        columns: [{
                                            caption:"2",
                                            headerCellTemplate: function (container) {
                                                container.html('3').parent().css({ fontSize: '10px', backgroundColor: '#f7ffce' }).attr({ 'rowspan': '' });
                                            },
                                            dataField: "Mui1_NgayTiem",
                                            alignment: "center"
                                        }]
                                    },
                                    {
                                        caption: "Lô vắc xin(*)",
                                        alignment: "center",
                                        columns: [{
                                            caption:"3",
                                            headerCellTemplate: function (container) {
                                                container.html('2').parent().css({ fontSize: '10px', backgroundColor: '#f7ffce' }).attr({ 'rowspan': '' });
                                            },
                                            dataField: "Mui1_SoLo",
                                            alignment: "center"
                                        }]
                                    },
                                    {
                                        headerCellTemplate: function (header, info) {
                                            $('<div>')
                                                .html("Địa điểm tiêm (*)</br>(Tham khảo PL4)")
                                                .appendTo(header);
                                        },
                                        alignment: "center",
                                        columns: [{
                                            caption:"4",
                                            headerCellTemplate: function (container) {
                                                container.html('4').parent().css({ fontSize: '10px', backgroundColor: '#f7ffce' }).attr({ 'rowspan': '' });
                                            },
                                            dataField: "Mui1_DiaDiem",
                                            alignment: "center"
                                        }]
                                    }
                                ]
                        },
                        {
                                caption: "Mũi 2",
                                alignment: "center",
                                fixed: flag_fixed,
                                columns: [
                                    {
                                        headerCellTemplate: function (header, info) {
                                            $('<div>')
                                                .html("Tên vắc xin (*)</br>(Tham khảo PL5)")
                                                .appendTo(header);
                                        },
                                        alignment: "center",
                                        columns: [{
                                            caption: "1",
                                            headerCellTemplate: function (container) {
                                                container.html('1').parent().css({ fontSize: '10px', backgroundColor: '#f7ffce' }).attr({ 'rowspan': '' });
                                            },
                                            dataField: "Mui2_TenVacxin",
                                            alignment: "center"
                                        }]
                                    },
                                    {
                                        headerCellTemplate: function (header, info) {
                                            $('<div>')
                                                .html("Ngày tiêm </br>dạng dd/mm/yyyy (*)")
                                                .appendTo(header);
                                        },
                                        alignment: "center",
                                        columns: [{
                                            caption:"2",
                                            headerCellTemplate: function (container) {
                                                container.html('3').parent().css({ fontSize: '10px', backgroundColor: '#f7ffce' }).attr({ 'rowspan': '' });
                                            },
                                            dataField: "Mui2_NgayTiem",
                                            alignment: "center"
                                        }]
                                    },
                                    {
                                        caption: "Lô vắc xin(*)",
                                        alignment: "center",
                                        columns: [{
                                            caption:"3",
                                            headerCellTemplate: function (container) {
                                                container.html('2').parent().css({ fontSize: '10px', backgroundColor: '#f7ffce' }).attr({ 'rowspan': '' });
                                            },
                                            dataField: "Mui2_SoLo",
                                            alignment: "center"
                                        }]
                                    },
                                    {
                                        headerCellTemplate: function (header, info) {
                                            $('<div>')
                                                .html("Địa điểm tiêm (*)</br>(Tham khảo PL4)")
                                                .appendTo(header);
                                        },
                                        alignment: "center",
                                        columns: [{
                                            caption:"4",
                                            headerCellTemplate: function (container) {
                                                container.html('4').parent().css({ fontSize: '10px', backgroundColor: '#f7ffce' }).attr({ 'rowspan': '' });
                                            },
                                            dataField: "Mui2_DiaDiem",
                                            alignment: "center"
                                        }]
                                    }
                                ]
                        },
                        {
                                caption: "Mũi 3",
                                alignment: "center",
                                fixed: flag_fixed,
                                columns: [
                                    {
                                        headerCellTemplate: function (header, info) {
                                            $('<div>')
                                                .html("Tên vắc xin (*)</br>(Tham khảo PL5)")
                                                .appendTo(header);
                                        },
                                        alignment: "center",
                                        columns: [{
                                            caption: "1",
                                            headerCellTemplate: function (container) {
                                                container.html('1').parent().css({ fontSize: '10px', backgroundColor: '#f7ffce' }).attr({ 'rowspan': '' });
                                            },
                                            dataField: "Mui3_TenVacxin",
                                            alignment: "center"
                                        }]
                                    },
                                    {
                                        headerCellTemplate: function (header, info) {
                                            $('<div>')
                                                .html("Ngày tiêm </br>dạng dd/mm/yyyy (*)")
                                                .appendTo(header);
                                        },
                                        alignment: "center",
                                        columns: [{
                                            caption:"2",
                                            headerCellTemplate: function (container) {
                                                container.html('3').parent().css({ fontSize: '10px', backgroundColor: '#f7ffce' }).attr({ 'rowspan': '' });
                                            },
                                            dataField: "Mui3_NgayTiem",
                                            alignment: "center"
                                        }]
                                    },
                                    {
                                        caption: "Lô vắc xin(*)",
                                        alignment: "center",
                                        columns: [{
                                            caption:"3",
                                            headerCellTemplate: function (container) {
                                                container.html('2').parent().css({ fontSize: '10px', backgroundColor: '#f7ffce' }).attr({ 'rowspan': '' });
                                            },
                                            dataField: "Mui3_SoLo",
                                            alignment: "center"
                                        }]
                                    },
                                    {
                                        headerCellTemplate: function (header, info) {
                                            $('<div>')
                                                .html("Địa điểm tiêm (*)</br>(Tham khảo PL4)")
                                                .appendTo(header);
                                        },
                                        alignment: "center",
                                        columns: [{
                                            caption:"4",
                                            headerCellTemplate: function (container) {
                                                container.html('4').parent().css({ fontSize: '10px', backgroundColor: '#f7ffce' }).attr({ 'rowspan': '' });
                                            },
                                            dataField: "Mui3_DiaDiem",
                                            alignment: "center"
                                        }]
                                    }
                                ]
                        },
                        {
                            dataField: "GhiChu",
                            caption: "Ghi chú",
                            allowEditing: false,
                        },
                        {
                            dataField: "KetQuaImport",
                            headerCellTemplate: function (header, info) {
                                $('<div>')
                                    .html("Kết quả import</br> (không điền ô này)")
                                    .appendTo(header);
                            },
                            allowEditing: false,
                        },
                    ],
                    showBorders: true,
                    searchPanel: {
                        visible: true,
                        highlightCaseSensitive: true
                    },
                    headerFilter: {
                        visible: true
                    },
                    loadPanel: {
                        enabled: false
                    },selection: {
                       // mode: "multiple"
                    },
                    //paging: { enabled: false },
                    columnAutoWidth: true,
                    scrolling: {
                        useNative: true,
                        scrollByContent: true,
                        scrollByThumb: true,
                        showScrollbar: "always" // or "onScroll" | "always" | "never"
                    }, export: {
                        enabled: true
                    },
                    onExporting(e) {
                      const workbook = new ExcelJS.Workbook();
                      const worksheet = workbook.addWorksheet('Sheet 1');
                      var borderStylePattern = { style: 'thick', color: { argb: 'FF7E7E7E' } };
                      DevExpress.excelExporter.exportDataGrid({
                        component: e.component,
                        worksheet,
                        //topLeftCell: { row: 0, column: 1 },
                      }).then((cellRange) => {


                      }).then(() => {
                        workbook.xlsx.writeBuffer().then((buffer) => {
                          saveAs(new Blob([buffer], { type: 'application/octet-stream' }), 'danh-sach-theo-doi-tiem-vacxin.xlsx');
                        });
                      });
                      e.cancel = true;
                    },
                });

            },
            error: function (e) {

            }
            });
        }
    });

</script>